package net.sf.itcb.common.web.vaadin.interceptor.request.impl;

import javax.portlet.PortletRequest;
import javax.servlet.http.HttpServletRequest;

import net.sf.itcb.common.web.portal.PortalAdapter;
import net.sf.itcb.common.web.portal.PortalAdapterProvider;
import net.sf.itcb.common.web.vaadin.ItcbVaadinApplication;
import net.sf.itcb.common.web.vaadin.interceptor.request.ItcbRequestInterceptor;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Required;

/**
 * This filter retrieves the specific PortalAdapter (Liferay...) then set the SpringSecurityContextHolder with user, password and roles from the portal request context
 * It fills the user in application 
 * 
 * @author Pierre Le Roux
 */
public class ThemeInterceptor implements ItcbRequestInterceptor {

	protected final Logger log = LoggerFactory.getLogger(getClass());

	protected net.sf.itcb.common.web.portal.PortalAdapterProvider portalAdapterProvider;

	@Required
	public void setPortalAdapterProvider(PortalAdapterProvider portalAdapterProvider) {
		this.portalAdapterProvider = portalAdapterProvider;
	}
	
	@Override
	public void handleRequestStart(ItcbVaadinApplication application,
			HttpServletRequest servletRequest) {
		// TODO fill the theme with spring configuration
	}

	@Override
	public void handleRequestStart(ItcbVaadinApplication application,
			PortletRequest portletRequest) {
		PortalAdapter portalAdapter = (PortalAdapter)portalAdapterProvider.getPortalAdapter(portletRequest);
		application.setTheme(portalAdapter.getTheme(portletRequest));
		application.getMainWindow().setTheme(portalAdapter.getTheme(portletRequest));
	}

	@Override
	public void handleRequestEnd(ItcbVaadinApplication application,
			HttpServletRequest servletRequest) {
		// Nothing
	}

	@Override
	public void handleRequestEnd(ItcbVaadinApplication application,
			PortletRequest portletRequest) {
		// Nothing
	}

}
