package net.sf.itcb.common.web.vaadin.page.config;

import org.springframework.oxm.jaxb.Jaxb2Marshaller;

import com.vaadin.ui.Button;
import com.vaadin.ui.Component;

import net.sf.itcb.common.web.vaadin.component.impl.ContextAnalyserPanel;

public class ContextHolder {

	public Jaxb2Marshaller marshaller;
	
	Object navigationContext;
	
	public void setJaxb2Marshaller(Jaxb2Marshaller marshaller) {
		this.marshaller=marshaller;
	}
	
	/**
	 * This function returns the navigation context
	 * @return
	 */
	public Object getNavigationContext() {
		return navigationContext;
	}
	
	/**
	 * This function returns the navigation context
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public <T extends Object> T getNavigationContext(Class<T> returnClass) {
		return (T)navigationContext;
	}
	
	/**
	 * This function returns the navigation context
	 * @return
	 */
	public void setNavigationContext(Object navigationContext) {
		this.navigationContext = navigationContext;
	}
	
	
	public ContextAnalyserPanel getContextAnalyserPanel() {
		return new ContextAnalyserPanel(marshaller, this);
	}
	
	public ContextAnalyserPanel getContextAnalyserPanel(final Button.ClickListener specificListener) {
		return new ContextAnalyserPanel(marshaller, this, null, specificListener);
	}
	
	public ContextAnalyserPanel getContextAnalyserPanel(final Component specificComponentToAdd, final Button.ClickListener specificListener) {
		return new ContextAnalyserPanel(marshaller, this, specificComponentToAdd, specificListener);
	}
}
